require 'yaml'

class Config
  attr_reader :redmine_uri

  def initialize(config_path='repos.yaml')
    config_path = config_path
    raw_config = read_config(config_path)
    @redmine_uri = raw_config['redmine']
    @repos = raw_config['repos'].map do |repo|
      repo.keys.reduce([]) do |pairs, key|
        pairs << [key.to_sym, repo[key]]
      end.to_h
    end
  end

  def each_repo
    @repos.each do |repo|
      yield repo
    end
  end

  private

  def read_config(config_path)
    YAML.load(File.read(config_path))
  end
end
