require 'test_helper'

describe Config do
  TEST_YAML_DATA = <<END
redmine: http://ya.ru
repos:
  - repo: http://ya.ru
    directory: info
    project: data
  - repo: http://duckduckgo.com
    directory: free
    project: test-one
END

  describe '#initialize' do
    it 'should correctly parse YAML data' do
      file_path = 'some_file.yaml'
      File.expects(:read).with(file_path).returns(TEST_YAML_DATA)
      Config.new(file_path)
    end

    it 'should store data about repositories in config fields' do
      file_path = 'data.yaml'
      File.expects(:read).with(file_path).returns(TEST_YAML_DATA)
      config = Config.new(file_path)
      expect(config.redmine_uri).must_equal 'http://ya.ru'
      config.each_repo do |repo|
        expect(repo.has_key?(:repo)).must_equal true
        expect(repo.has_key?(:directory)).must_equal true
        expect(repo.has_key?(:project)).must_equal true
      end
    end
  end
end
